# Copyright (c) 2023-present eyeo GmbH
#
# This module is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

---

testpages_repo:
  "https://gitlab.com/eyeo/developer-experience/testpages.adblockplus.org"

# provision-eyeo-cms-web-servers.yml
testpages_eyeo_cms_content_repos__to_merge:
  "{{ testpages_primary_domain }}":
    name: "{{ testpages_primary_domain }}"
    repo: "{{ testpages_repo }}"
    version: "{{ testpages_version }}"
  "{{ testpages_secondary_domain }}":
    name: "{{ testpages_secondary_domain }}"
    repo: "{{ testpages_repo }}"
    version: "{{ testpages_version }}"

# roles/apache2/tasks/main.yml
# provision-apache2-servers.yml
testpages_apache2_modules__to_merge:
  ssl: &apache2_standard_module
    package: false

# this subdomain -> domain document root link exists because we implement
# rebuilds through virtual host settings, and there's no need for a third
# build just because of the subdomain
# tasks/commands.yml
# yamllint disable rule:line-length
testpages_subdomain_custom_commands__to_merge:
  1_prepare_subdomain_document_root:
    cmd: "ln -s {{ testpages_secondary_domain }}
                {{ eyeo_cms_content_output_dir }}/{{ testpages_secondary_subdomain }}"
    creates: "{{ eyeo_cms_content_output_dir }}/{{ testpages_secondary_subdomain }}"
# yamllint enable rule:line-length

# TODO: fully parametrize port 4000, match it to an environment file
# endpoints/start.js const HTTP_PORT = 4000;
testpages_endpoints_server_port:
  "4000"

# TODO: fully parametrize port 4001, match it to an environment file
testpages_endpoints_websocket_port:
  "4001"

# TODO: fully parametrize port 4001, match it to an environment file
testpages_endpoints_exception_websocket_port:
  "4002"

testpages_endpoints_base_url:
  "/sitekey-frame"

testpages_endpoints_websocket_url:
  "/websocket"

testpages_endpoints_exception_websocket_url:
  "/exception_websocket"

# yamllint disable rule:line-length
testpages_endpoints_extra_apache_config: |
  # HTTP endpoint
  ProxyPass /server-status !
  ProxyPreserveHost On
  ProxyPass {{ testpages_endpoints_base_url }} "http://localhost:{{ testpages_endpoints_server_port }}{{ testpages_endpoints_base_url }}"
  ProxyPassReverse {{ testpages_endpoints_base_url }} "http://localhost:{{ testpages_endpoints_server_port }}{{ testpages_endpoints_base_url }}"

  RewriteEngine On

  # Websocket endpoint
  RewriteCond ${HTTP:Upgrade} websocket [NC]
  RewriteCond ${HTTP:Connection} upgrade [NC]
  RewriteRule {{ testpages_endpoints_websocket_url }} wss://localhost:{{ testpages_endpoints_websocket_port }} [P,L]
  ProxyPass "{{ testpages_endpoints_websocket_url }}" "http://localhost:{{ testpages_endpoints_websocket_port }}/" upgrade=websocket
  ProxyPassReverse "{{ testpages_endpoints_websocket_url }}" "http://localhost:{{ testpages_endpoints_websocket_port }}/" upgrade=websocket

  # Exception websocket endpoint
  RewriteCond ${HTTP:Upgrade} websocket [NC]
  RewriteCond ${HTTP:Connection} upgrade [NC]
  RewriteRule {{ testpages_endpoints_exception_websocket_url }} wss://localhost:{{ testpages_endpoints_exception_websocket_port }} [P,L]
  ProxyPass "{{ testpages_endpoints_exception_websocket_url }}" "http://localhost:{{ testpages_endpoints_exception_websocket_port }}/" upgrade=websocket
  ProxyPassReverse "{{ testpages_endpoints_exception_websocket_url }}" "http://localhost:{{ testpages_endpoints_exception_websocket_port }}/" upgrade=websocket

# yamllint enable rule:line-length

testpages_endpoints_dest_dir:
  "/srv/testpages-endpoints"

# tasks/services.yml
testpages_endpoints_custom_services__to_merge:
  # TODO: add EnvironmentFile: "{{ testpages_endpoints_dir }}/server.env"
  # NB: WorkingDirectory assumed for master branch
  testpages-endpoints:
    enabled: "{{ testpages_endpoints_service_enabled }}"
    state: "{{ testpages_endpoints_service_state }}"
    service:
      Unit:
        Description: "Run Testpages Endpoints server"
        After: "network.target"
      Service:
        Type: "simple"
        User: "{{ testpages_endpoints_user }}"
        WorkingDirectory: "{{ testpages_endpoints_dest_dir }}"
        # package.json start-endpoints
        ExecStart: "/usr/bin/npm run start-endpoints"
        Restart: "on-failure"
      Install:
        WantedBy: "multi-user.target"

# task/paths.yml
testpages_endpoints_prerequisite_paths__to_merge:
  /etc/sudoers.d/deploy_testpages:
    state: "copy"
    mode: "0440"
    content: |
      Defaults:gitlab-runner env_keep += "CI_COMMIT_REF_SLUG"
      gitlab-runner ALL=(root) NOPASSWD: /usr/local/sbin/deploy_testpages
      gitlab-runner ALL=(root) NOPASSWD: /usr/local/sbin/undeploy_testpages
    validate:
      "/usr/sbin/visudo --check --file=%s"
  /usr/local/sbin/deploy_testpages:
    state: "template"
    mode: "0755"
    src: "files/testpages/deploy_testpages"
  /usr/local/sbin/undeploy_testpages:
    state: "template"
    mode: "0755"
    src: "files/testpages/undeploy_testpages"
  "{{ testpages_endpoints_dest_dir }}":
    dest: "{{ testpages_endpoints_dest_dir }}"
    state: "directory"
    mode: "0755"
    owner: "{{ testpages_endpoints_user }}"
